package physicssim;
import java.awt.*;

/**
 * <p>Title: physicssim (can you think of a better name?)</p>
 * <p>Description: A physics simulator using clados</p>
 * <p>Copyright: GNU General Public License.  A full copy of the license can be found bundled with this package.
 * <p>Company: </p>
 * @author Martin Baker and Alfred Differ
 * @version 1.0
 */

public class sphere extends shape {

private double[] icosahedron = new double[36];
private double r=20;
public int offsetx = 140;
public int offsety = 200;
public int step= -1;

int[] coord_index = {0,1,2,0,2,3,0,3,4,0,4,5,0,5,1,1,6,2,2,6,7,2,7,3,3,7,8,3,8,4,4,8,9,
       4,9,5,5,9,10,5,10,1,1,10,6,11,7,6,11,8,7,11,9,8,11,10,9,11,6,10};

public sphere() {
  double angle36 = Math.PI/5;
  double angle72 = 2*angle36;
  for (int i=0; i<12; i++) {
    if (i==0) {
      icosahedron[i*3] =0; //north pole
      icosahedron[i*3+1] =0;
      icosahedron[i*3+2] =r;
    } else if (i<6) {
      double alpha = (i-1) * angle72;
      icosahedron[i*3] =Math.cos(alpha)*r;
      icosahedron[i*3+1] =Math.sin(alpha)*r;
      icosahedron[i*3+2] =r/Math.sqrt(5);
      toRadiusCircle(i,r);
    } else if (i<11) {
      double alpha = angle36 + (i-6) * angle72;
      icosahedron[i*3] =Math.cos(alpha)*r;
      icosahedron[i*3+1] =Math.sin(alpha)*r;
      icosahedron[i*3+2] =-r/Math.sqrt(5);
      toRadiusCircle(i,r);
    } else {
      icosahedron[i*3] =0; //south pole
      icosahedron[i*3+1] =0;
      icosahedron[i*3+2] =-r;
    }
  }
}

/** override shape.paint method
*
*/
public void paint(Graphics g) {
  offsety += step;
  if (offsety<0) step=1;
  if (offsety>200) step=-1;
  // approximate as icosahedron
      try {
        for (int face=0;face<12;face++) {
            g.drawLine(
                (int)(icosahedron[coord_index[face*3]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3]*3+1]+offsety),
                (int)(icosahedron[coord_index[face*3+1]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3+1]*3+1]+offsety));
            g.drawLine(
                (int)(icosahedron[coord_index[face*3+1]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3+1]*3+1]+offsety),
                (int)(icosahedron[coord_index[face*3+2]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3+2]*3+1]+offsety));
            g.drawLine(
                (int)(icosahedron[coord_index[face*3+2]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3+2]*3+1]+offsety),
                (int)(icosahedron[coord_index[face*3]*3]+offsetx),
                (int)(icosahedron[coord_index[face*3]*3+1]+offsety));
      }
      } catch (Exception e) {
        System.out.println("sphere.paint " + e.toString());
      }
}


  public void toRadiusCircle(int i,double r) {
    double correction = Math.sqrt(icosahedron[i*3]*icosahedron[i*3]+
                                  icosahedron[i*3+1]*icosahedron[i*3+1]+
                                  icosahedron[i*3+2]*icosahedron[i*3+2]);
    icosahedron[i*3] = icosahedron[i*3] * r / correction;
    icosahedron[i*3+1] = icosahedron[i*3+1] * r / correction;
    icosahedron[i*3+2] = icosahedron[i*3+2] * r / correction;
  }


}